
n = 100;

%xCheby = cos(((1:n)'-0.5)*pi/n);
xCheby = zeros(n, 1);
for j = 1:n
    xCheby(j) = cos((j - 0.5)/n * pi);
end


T = zeros(n);
T(1,2) = 1;
for i = 2:n-1
    T(i,i-1) = 0.5;
    T(i,i+1) = 0.5;
end
T(n,n-1) = 0.5;

% T = spdiags(0.5*ones(N,2), [-1,1], N,N);
% T(1,2) = 1;
% T = full(T);

xEig = eig(T);
xEig = sort(xEig, 'descend');

maxAbsError = max(abs(xEig - xCheby));
fprintf('Maximum absolute difference between the eigenvalues and chebyshev points is %e\n', maxAbsError);