


n = 10;

a = 0;
b = 1;

% Stützstellen
xk = linspace(0, 1, n+1);

f = @cos; % Short for @(x) cos(x)
Int_Referenz = sin(1);

%f = @sin;
%Int_Referenz = 1-cos(1);

% Zusammengesetzte Trapezregel
Int_Trapez = (b-a)/n * (0.5*f(xk(1)) + sum(f(xk(2:end-1))) + 0.5*f(xk(end)));

% Zusammengesetzte Simpsonregel
Int_Simpson = (b-a)/(3*n) * (f(xk(1)) + f(xk(end)) + 2*sum(f(xk(3:2:end-2))) + 4*sum(f(xk(2:2:end-1))));

% Romberg-Integration
Int_Trapez_grob = (b-a)/(n/2) * (0.5*f(xk(1)) + sum(f(xk(3:2:end-2))) + 0.5*f(xk(end)));
Int_Romberg = Int_Trapez + (Int_Trapez - Int_Trapez_grob)/3;

% Matlab's integral
Int_Matlab = integral(f, a, b);

% Print results
fprintf('Trapezregel grob - Absoluter Fehler: %e\n', abs(Int_Trapez_grob - Int_Referenz));
fprintf('Trapezregel - Absoluter Fehler: %e\n', abs(Int_Trapez - Int_Referenz));
fprintf('Simpsonregel - Absoluter Fehler: %e\n', abs(Int_Simpson - Int_Referenz));
fprintf('Romberg-Integration - Absoluter Fehler: %e\n', abs(Int_Romberg - Int_Referenz));
fprintf('Matlab''s integral - Absoluter Fehler: %e\n', abs(Int_Matlab - Int_Referenz));
